/*!
* TrackFunctions.js
* version: "COR 1.1"
* Date: 05.03.2014
*
* Note:
* Script per il tracciamento Nielsen & Omniture.
*
* v. 1.0:		funzione checkNielsenImg()		Cerca e nel caso appende l'immagine per l'invio della chiamata Nielsen
* 				funzione TrackNielsen			Gestione tracciamento Nielsen sfoglie e refesh
* 												ex#1: TrackNielsen("refesh-cens");
*	 											ex#2: TrackNielsen("refresh_ce-awe");
* 
* v. 1.1:		vscroll							Traccia automatizzato max % di scroll dell'HP
*/

/******************************************************************************/
//cerca se esiste immagine Nielsen
/******************************************************************************/
function checkNielsenImg() {
	if (!jQuery("#nielsen_img").length) {
		jQuery("body").append("<img id='nielsen_chk_img' src='http://images.corriereobjects.it/images/static/common/nib.gif' style='display:none' />");
	}
}

/******************************************************************************/
//Tracciamento jquery nielsen
/******************************************************************************/
function TrackNielsen(refesh_type) {
	checkNielsenImg();

	rnd_number = Math.floor((Math.random()) * 10000000000000);
	url = escape(document.URL);
	jQuery("#nielsen_chk_img").attr("src", "http://secure-it.imrworldwide.com/cgi-bin/m?rnd=" + rnd_number + "&ci=rcs-it&cg=0&si=" + url + "%26" + refesh_type);
}

/******************************************************************************/
//indexOf for ie8 / ie7
/******************************************************************************/
if (!Array.prototype.indexOf) {
	Array.prototype.indexOf = function(elt /*, from*/) {
		var len = this.length >>> 0;

		var from = Number(arguments[1]) || 0;
		from = (from < 0) ? Math.ceil(from) : Math.floor(from);
		if (from < 0)
			from += len;

		for (; from < len; from++) {
			if ( from in this && this[from] === elt)
				return from;
		}
		return -1;
	};
}

/******************************************************************************/
//inizio vscoll
/******************************************************************************/
var vscroll = true;

function vscroll_track(Scrollmax) {
	//s.un = 'rcscorriereproddef';
	s.linkTrackVars = '';
	s.prop70 = Scrollmax + "%";
	s.tl('corriere.it', 'o', 'Max scrolling');
}

function VistaVerticale() {
	Scrollpos = jQuery(window).scrollTop();
	WinHeight = jQuery(window).height();
	if (window.innerHeight && window.scrollMaxY) {
		TotHeight = window.innerHeight + window.scrollMaxY;
	} else if (document.body.scrollHeight > document.body.offsetHeight) {
		TotHeight = document.body.scrollHeight;
	} else {
		TotHeight = document.body.offsetHeight;
	}
	Vista = Scrollpos + WinHeight;
	Perc = (Vista * 100) / TotHeight;
	if (Perc > 100) {
		Perc = 100;
	}
	return Math.ceil(Perc);
}

//Script limitato alla sola HP
if (typeof sezione != 'undefined') {
	if (sezione == "home") {
		jQuery(window).load(function() {
			if (vscroll) {
				var ScrollNow = 0;
				var Scrollmax = VistaVerticale();
	
				jQuery(window).scroll(function() {
					ScrollNow = VistaVerticale();
					if (ScrollNow > Scrollmax) {
						Scrollmax = ScrollNow;
					}
				});
	
				jQuery(window).unload(function() {
					if (s.pageURL.indexOf('refresh_ce') > -1) {
						if (ScrollNow != 0) {
							vscroll_track(Scrollmax);
						} else {
							//console.log("ce presente e no scroll");
						}
					} else {
						vscroll_track(Scrollmax);
					}
				});
			}
		});
	}
}
//fine vscroll