/*
 *      NYRB Require JS Module:
 *          app.js
 *
 *      desc:
 *          This file specifies the JS modules to be loaded and initialized by Require JS.
 *
 */

requirejs.config({
    paths: {
        "jquery": "lib/jquery",
        "throttledresize": "lib/throttledresize",
        "timelinr": "lib/jquery.timelinr-0.9.52",
        "util": "nyrb/util",
        "resize": "nyrb/resize",
        "fifty_years": "nyrb/fifty_years",
        "browse_filter": "nyrb/browse_filter",
        "accordion": "nyrb/accordion",
        "events" : "nyrb/events",
        "urijs" : "lib/URI",
        "add_to_home": "nyrb/add_to_home",
        "addtohome" : "lib/addToHome",
        "cookie" : "lib/jquery.cookie",
        "magnific" : "lib/jquery.magnific-popup.min",
        // "popup" : "nyrb/popup",
        // "timeline" : "nyrb/timeline",
        // "ad_manager" : "nyrb/ad_manager",
        "iconfont_fallback" : "lib/iconfont-fallback",
        "modernizr" : "lib/modernizr",
        "isFontFaceSupported" : "lib/isFontFaceSupported",
        "fallback" : "nyrb/fallback",
        "browser_detect" : "lib/browser_detect",
        "replace_logo" : "nyrb/replace_logo"
        // "fitvids" : "lib/jquery.fitvids",
        // "vid_resize" : "nyrb/vid_resize"
    },
    shim: {
        "urijs": {
            deps: ['jquery'],
            exports: 'URI'
        },
        "addtohome": {
            exports: 'addToHome'
        },
        "cookie": {
            deps: ['jquery'],
            exports: 'cookie'
        },
        // "magnific": {
        //     deps: ['jquery'],
        //     exports: 'magnific'
        // },
        "timelinr": {
            deps: ['jquery'],
            exports: 'timelinr'
        },
        "iconfont_fallback": {
            deps: ['jquery'],
            exports: 'iconfont_fallback'
        },
        "modernizr": {
            exports: 'modernizr'
        },
        "isFontFaceSupported": {
            exports: 'isFontFaceSupported'
        },
        "browser_detect": {
            exports: 'browser_detect'
        },
        // "fitvids": {
        //     deps: ['jquery'],
        //     exports: 'fitvids'
        // }
    }
});

requirejs([
        "jquery",
        "throttledresize",
        "timelinr",
        "util",
        "resize",
        "fifty_years",
        "browse_filter",
        "accordion",
        "events",
        "urijs",
        "add_to_home",
        "addtohome",
        "cookie",
        // "magnific",
        // "popup",
        // "ad_manager",
        "iconfont_fallback",
        "modernizr",
        "isFontFaceSupported",
        "fallback",
        "browser_detect",
        "replace_logo"
        // "fitvids",
        // "vid_resize"
    ], function (
        $,
        throttledresize,
        timelinr,
        util,
        resize,
        fifty_years,
        browse_filter,
        accordion,
        events,
        urijs,
        add_to_home,
        addtohome,
        cookie,
        // magnificPopup,
        // popup,
        // ad_manager,
        iconfont_fallback,
        modernizr,
        isFontFaceSupported,
        fallback,
        browser_detect,
        replace_logo
        // fitvids,
        // vid_resize
    ){
});
