/*
 *      NYRB JS Module:
 *          events.js
 *
 *      desc:
 *          This file contains functions used for checkbox filtering in the events sidebar.
 *
 */

define( ['jquery', 'util', 'urijs' ], function ( $, util, URI ) {

	var _initialized = true,
		debug = util.debug
	;

	_bind_events();

	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

	function _bind_events() {

		// Filter behavior

		$('.filter_option a').off('click').on('click', function(e) {

			var $this = $(this),
				query = URI(location.search),
				$parent = $this.closest('.filter_option'),
				$checkbox = $parent.find('input[type="checkbox"]'),
				prefix = 'category_',
				cat_id = $checkbox.attr('data-id'),
				cat_name = cat_id.substring(cat_id.indexOf(prefix) + prefix.length),
				$module = $(this).closest('.event_filters_content');

			query.removeSearch('category');
			query.removeSearch('page');

			if ($this.hasClass('selected')) {

				// $this.removeClass('selected');
				// $checkbox.attr('checked', false);

				$('.filter_option label[for="' + cat_id + '"] a').removeClass('selected');
				$('.filter_option input[type="checkbox"][data-id="' + cat_id + '"]').attr('checked', false);

			} else {

				// $this.addClass('selected');
				// $checkbox.attr('checked', true);

				$('.filter_option label[for="' + cat_id + '"] a').addClass('selected');
				$('.filter_option input[type="checkbox"][data-id="' + cat_id + '"]').attr('checked', true);

				if (cat_name !== 'all') {

					// Uncheck "all" immediately if another filter is selected
					$('.event_filters_content input[type="checkbox"][id="category_all"]').attr('checked', false);

				}

			}

			// debug( query );

			if ($this.parent().parent().children().first().attr('data-id') != 'category_all') {

				$module.find('input[type="checkbox"]').each(function () {

					var $this = $(this),
						$this_parent = $this.closest('.filter_option'),
						$anchor = $this_parent.find('a'),
						$this_checkbox = $this_parent.find('input[type="checkbox"]'),
						this_cat_id = $this_checkbox.attr('data-id'),
						this_cat_name = this_cat_id.substring(this_cat_id.indexOf(prefix) + prefix.length);

					if (this_cat_name != 'all') {

						if ($anchor.hasClass('selected') === true) {

							query = query.addSearch('category', this_cat_name);

						} else {

							query = query.removeSearch('category', this_cat_name);

						}

					}

				});

			}

			debug( query );

			location.search = query;

			e.stopPropagation();

		});

		$('.filter_option input[type="checkbox"]').off('click').on('click', function(e) {

			e.stopPropagation();

			var $parent = $(this).closest('.filter_option'),
				$anchor = $parent.find('a');

			$anchor.trigger('click');

		});

	}

	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

});
